/*
 * Copyright (c) 2011 Sprite_tm <jeroen@spritesmods.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * For more information on the GPL, please go to:
 * http://www.gnu.org/copyleft/gpl.html
 */

#include <avr/io.h>
#include <avr/pgmspace.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <util/delay.h>

#include "config.h"
#include "core/eeprom.h"
#include "protocols/ecmd/ecmd-base.h"
#include "hardware/z80interface/z80interface.h"

static char *findNextArg(char *str) {
	while (*str!=' ' && *str!=0) str++;
	while (*str==' ') str++;
	return str;
}

//Write a message to the display
int16_t parse_cmd_1943_msg(char *cmd, char *output, uint16_t len) {
	int duration;
	cmd=findNextArg(cmd);
	duration=strtol(cmd, NULL, 10);
	cmd=findNextArg(cmd);
	arcade1943_setMessage(cmd, duration);
	return ECMD_FINAL(0);
}

//Gt hiscore table.
int16_t parse_cmd_1943_readhs(char *cmd, char *output, uint16_t len) {
	int position, l;
	//borrowed the idea from protocols/ecmd/parser.c, parse_cmd_help()
	if (cmd[0]!=23) {
		cmd[0]=23;
		cmd[1]=0;
	}
	position=cmd[1];
	l=arcade1943_getHiScoreString(output, position);
	cmd[1]++;
	return (cmd[1]!=5)?ECMD_AGAIN(l):ECMD_FINAL(l);
}

/*
-- Ethersex META --
block([[Arcade1943]])
ecmd_feature(1943_readhs, "1943_readhs",POSITION, Read 1943 highscore position n)
ecmd_feature(1943_msg, "1943_msg",DURATION POSITION, Write message to screen for the indicated amount of seconds)
*/
