/*
Silly little program that uses the Z80 (with a bit of SRAM on its bus) as a
coprocessor to do addition of two numbers. Basically tests the concept of the AVR
hijacking the Z80s bus.
*/
#include "io.h"
#include "stdout.h"
#include <stdio.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include "z80code.h"


//Let the Z80 add 2 bytes. Most idiotic use of a Z80 as a subprocessor ever :P
unsigned char z80Add(unsigned char c1, unsigned char c2) {
	unsigned char ret;
	z80TakeOverBus();
	z80SetMem(0x102, 0);
	z80SetMem(0x100, c1);
	z80SetMem(0x101, c2);
	z80ReleaseBus();
	_delay_ms(1);
	z80TakeOverBus();
	ret=z80ReadMem(0x102);
	z80ReleaseBus();
	printf("%hhi + %hhi = %hhi\n", c1, c2, ret);
	return ret;
}

int main() {
	unsigned int x;
	unsigned char c1, c2, c3;
	ioInit();
	stdoutInit(64); //20 MHz -> 19200 baud
	printf("Uploading program.\n");
	z80TakeOverBus();
	for (x=0; x<32; x++) {
		z80SetMem(x, pgm_read_byte(&z80code[x]));
	}

	printf("Verifying...\n");
	for (x=0; x<32; x++) {
		c1=pgm_read_byte(&z80code[x]);
		c2=z80ReadMem(x);
		if (c1!=c2) printf("Addr 0x%x: w %hhx, r %hhx\n", x, (int)c1, (int)c2);
	}

	printf("Done. Resetting Z80\n");
	z80ReleaseBus();
	z80Reset();

	while(1) {
		c1++;
		c2=c2^c1&0xA9;
		c3=z80Add(c1, c2);
		//See if the Z80 actually does add the two numbers correctly.
		if ((unsigned char)(c1+c2)!=c3) return;
	}


}