#include <stdio.h>
#include <avr/io.h>
#include <avr/sleep.h>
#include <avr/interrupt.h>

#ifndef UCSR0A
#define UCSR0A UCSRA
#define UCSR0B UCSRB
#define UDR0 UDR
#define UBRR0H UBRRH
#define UBRR0L UBRRL
#endif

static int uart_putchar(char c, FILE *stream) {
    if (c=='\n') uart_putchar('\r', stream);
    while(!(UCSR0A&0x20)) ;
    UDR0=c;
    return 0;
}

static FILE mystdout = FDEV_SETUP_STREAM(uart_putchar, NULL, _FDEV_SETUP_WRITE);

void stdoutInit(int ubr) {
    UCSR0B=0x18;
    UBRR0L=ubr&0xff;
    UBRR0H=ubr>>8;
    stdout = &mystdout;
}
